#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2014年 10月 27日 月曜日 06:49:46 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_

#if __SIMULATE__
static int	kernel_id;
#endif

long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	struct _t { long id; double a; double o1; double o2; double o3; int cycle; }
	model[] = {
		 // KERNEL_IDX=0  BLOCK_SIZE=384  UMAX=2  VMAX=1  UNROLL=1  CYCLE=128
		{ 0x0101020180,    45.3385,    655.759,    95.7139,          0, 128 },
		 // KERNEL_IDX=1  BLOCK_SIZE=256  UMAX=2  VMAX=1  UNROLL=1  CYCLE=224
		{ 0x0101020100,    45.2881,    600.691,    108.857, -0.00751096, 224 },
		 // KERNEL_IDX=2  BLOCK_SIZE=32  UMAX=3  VMAX=4  UNROLL=1  CYCLE=2304
		{ 0x0104030020,    43.5789,    474.381,    164.678,     0.0411, 2304 },
		 // KERNEL_IDX=3  BLOCK_SIZE=352  UMAX=2  VMAX=1  UNROLL=1  CYCLE=160
		{ 0x0101020160,    45.3348,    649.291,    95.1279,          0, 160 },
		 // KERNEL_IDX=4  BLOCK_SIZE=384  UMAX=1  VMAX=1  UNROLL=1  CYCLE=64
		{ 0x0101010180,    45.7637,    789.426,    186.343,          0, 64 },
		 // KERNEL_IDX=5  BLOCK_SIZE=192  UMAX=2  VMAX=1  UNROLL=1  CYCLE=288
		{ 0x01010200c0,    45.4068,    566.472,    134.719,  0.0449292, 288 },
		 // KERNEL_IDX=6  BLOCK_SIZE=288  UMAX=2  VMAX=1  UNROLL=1  CYCLE=192
		{ 0x0101020120,    45.2632,    623.466,    90.5462, -0.0522887, 192 },
		 // KERNEL_IDX=7  BLOCK_SIZE=224  UMAX=2  VMAX=1  UNROLL=1  CYCLE=256
		{ 0x01010200e0,    45.2931,     577.04,    117.855, -0.0184365, 256 },
		 // KERNEL_IDX=8  BLOCK_SIZE=32  UMAX=3  VMAX=3  UNROLL=1  CYCLE=2304
		{ 0x0103030020,    43.5708,    478.994,    147.763,  0.0294602, 2304 },
		 // KERNEL_IDX=9  BLOCK_SIZE=160  UMAX=2  VMAX=1  UNROLL=1  CYCLE=320
		{ 0x01010200a0,    45.2073,    561.138,    136.871,  0.0542538, 320 },
		 // KERNEL_IDX=10  BLOCK_SIZE=160  UMAX=2  VMAX=2  UNROLL=1  CYCLE=320
		{ 0x01020200a0,    45.2308,    554.519,     146.79,  0.0697052, 320 },
		 // KERNEL_IDX=11  BLOCK_SIZE=96  UMAX=2  VMAX=1  UNROLL=1  CYCLE=512
		{ 0x0101020060,     44.901,    550.452,    124.133, -0.0197411, 512 },
		 // KERNEL_IDX=12  BLOCK_SIZE=64  UMAX=8  VMAX=4  UNROLL=1  CYCLE=2560
		{ 0x0104080040,    44.1039,    389.711,    368.257,   0.105513, 2560 },
		 // KERNEL_IDX=13  BLOCK_SIZE=64  UMAX=6  VMAX=3  UNROLL=1  CYCLE=1728
		{ 0x0103060040,     45.822,    329.773,    492.344,   0.141663, 1728 },
		 // KERNEL_IDX=14  BLOCK_SIZE=320  UMAX=2  VMAX=1  UNROLL=1  CYCLE=160
		{ 0x0101020140,    45.4843,    623.332,    111.932,          0, 160 },
		 // KERNEL_IDX=15  BLOCK_SIZE=352  UMAX=1  VMAX=1  UNROLL=1  CYCLE=80
		{ 0x0101010160,    45.5967,    766.501,    183.984,          0, 80 },
		 // KERNEL_IDX=16  BLOCK_SIZE=256  UMAX=1  VMAX=1  UNROLL=1  CYCLE=112
		{ 0x0101010100,    45.5901,    661.711,    161.592,          0, 112 },
		 // KERNEL_IDX=17  BLOCK_SIZE=288  UMAX=1  VMAX=1  UNROLL=1  CYCLE=96
		{ 0x0101010120,    45.5131,     690.51,    162.036,          0, 96 },
		 // KERNEL_IDX=18  BLOCK_SIZE=32  UMAX=5  VMAX=3  UNROLL=1  CYCLE=3840
		{ 0x0103050020,    42.2954,    438.142,    235.483,  0.0941773, 3840 },
		 // KERNEL_IDX=19  BLOCK_SIZE=320  UMAX=1  VMAX=1  UNROLL=1  CYCLE=80
		{ 0x0101010140,    45.4811,    724.685,    155.204,          0, 80 },
		{ 0, 0.0, 0.0, 0.0, 0.0, 0 }
	};

	int  MP = API(get_numbers_MP)();

	int	i, ii = 0; long t=0;
if ( blk < 0 ) {
	int	n = n2;
	double X=(double)n, fx=0.0f;
	for(i=0;model[i].id>0;i++){
		double a=(double)model[i].a;
		double o1=(double)model[i].o1;
		double o2=(double)model[i].o2;
		double o3=(double)model[i].o3;
		// int BLOCK_SIZE=((model[i].id>>0)&0xffff);
		// int UMAX=((model[i].id>>16)&0xff);
		// int VMAX=((model[i].id>>24)&0xff);
		// int UNROLL=((model[i].id>>32)&0xff);
		int B; B=model[i].cycle; if ( B <= 0 ) B=1;
		if (520<200) {
			if ( B > 1 && B <= 1500 && B > 11*MP ) {
                        	if ( n % B < MP*8 ) continue;
	                        if ( n % B > B-MP*3 ) continue;
			}
		}
		double f=a*(X*X)/((o1*o1)+(o2+o3*floor(X/B)*B+(1-o3)*X)*X);

//if ( B > 3600 || X < B * (MP-4)/MP || X > B )
		if(f>fx){ t=model[i].id; ii=i; fx=f; }
	} *ff=fx;
} else {
	int	n = n2;
	double X=(double)n;
	i = blk;
		double a=(double)model[i].a;
		double o1=(double)model[i].o1;
		double o2=(double)model[i].o2;
		double o3=(double)model[i].o3;
		int B; B=model[i].cycle; if ( B <= 0 ) B=1;
		double f=a*(X*X)/((o1*o1)+(o2+o3*floor(X/B)*B+(1-o3)*X)*X);
	ii = blk;
	*ff=f;
}

#if __SIMULATE__
	kernel_id = ii;
#else

#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
	case 0:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
	case 1:
		DGEMVT_KERNEL_ ( 256 , 1 , 2, 1 );
		break;
	case 2:
		DGEMVT_KERNEL_ ( 32 , 4 , 3, 1 );
		break;
	case 3:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
	case 4:
		DGEMVT_KERNEL_ ( 384 , 1 , 1, 1 );
		break;
	case 5:
		DGEMVT_KERNEL_ ( 192 , 1 , 2, 1 );
		break;
	case 6:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
	case 7:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
	case 8:
		DGEMVT_KERNEL_ ( 32 , 3 , 3, 1 );
		break;
	case 9:
		DGEMVT_KERNEL_ ( 160 , 1 , 2, 1 );
		break;
	case 10:
		DGEMVT_KERNEL_ ( 160 , 2 , 2, 1 );
		break;
	case 11:
		DGEMVT_KERNEL_ ( 96 , 1 , 2, 1 );
		break;
	case 12:
		DGEMVT_KERNEL_ ( 64 , 4 , 8, 1 );
		break;
	case 13:
		DGEMVT_KERNEL_ ( 64 , 3 , 6, 1 );
		break;
	case 14:
		DGEMVT_KERNEL_ ( 320 , 1 , 2, 1 );
		break;
	case 15:
		DGEMVT_KERNEL_ ( 352 , 1 , 1, 1 );
		break;
	case 16:
		DGEMVT_KERNEL_ ( 256 , 1 , 1, 1 );
		break;
	case 17:
		DGEMVT_KERNEL_ ( 288 , 1 , 1, 1 );
		break;
	case 18:
		DGEMVT_KERNEL_ ( 32 , 3 , 5, 1 );
		break;
	case 19:
		DGEMVT_KERNEL_ ( 320 , 1 , 1, 1 );
		break;
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

#if __SIMULATE__
main(int argc, char **argv){
  int blk=-1;
  if ( argc > 1 ) blk = atoi(argv[1]);
  while(1){
    int n; scanf("%d", &n); if(n<1)break;
    const double *x = NULL;
    double *y = NULL;
    double s; long k=do_best_kernel_DGEMVT(blk, 0.0, 0.0, x, x, y, 0, n, n, 0, &s);
    printf("%d BLK_SIZE=%d UMAX=%d VMAX=%d UNROLL=%d %g %d\n",
    n, ((k>>0)&0x0ffff), ((k>>16)&0xff), ((k>>24)&0xff), ((k>>32)&0xff), s,
	kernel_id);
  }
}
#endif
