#if 0
<--/****************************************
Automatic Performance Tuning for SGEMV -T
2014年 10月 27日 月曜日 10:12:38 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-980
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-980";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	float
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_SGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_6	1
#define	KERNEL_7	1
#define	KERNEL_9	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_16	1

if ( n >= 1 && n < 225 ) {
	BLK = 17;
} else
if ( n >= 225 && n < 571 ) {
	BLK = 9;
} else
if ( n >= 571 && n < 768 ) {
	BLK = 7;
} else
if ( n >= 768 && n < 798 ) {
	BLK = 9;
} else
if ( n >= 798 && n < 853 ) {
	BLK = 16;
} else
if ( n >= 853 && n < 1024 ) {
	BLK = 19;
} else
if ( n >= 1024 && n < 1152 ) {
	BLK = 7;
} else
if ( n >= 1152 && n < 1159 ) {
	BLK = 5;
} else
if ( n >= 1159 && n < 1280 ) {
	BLK = 12;
} else
if ( n >= 1280 && n < 1381 ) {
	BLK = 11;
} else
if ( n >= 1381 && n < 1461 ) {
	BLK = 7;
} else
if ( n >= 1461 && n < 1536 ) {
	BLK = 12;
} else
if ( n >= 1536 && n < 1600 ) {
	BLK = 5;
} else
if ( n >= 1600 && n < 1686 ) {
	BLK = 11;
} else
if ( n >= 1686 && n < 1792 ) {
	BLK = 12;
} else
if ( n >= 1792 && n < 1920 ) {
	BLK = 7;
} else
if ( n >= 1920 && n < 1972 ) {
	BLK = 11;
} else
if ( n >= 1972 && n < 2048 ) {
	BLK = 12;
} else
if ( n >= 2048 && n < 2061 ) {
	BLK = 11;
} else
if ( n >= 2061 && n < 2197 ) {
	BLK = 5;
} else
if ( n >= 2197 && n < 2304 ) {
	BLK = 12;
} else
if ( n >= 2304 && n < 2355 ) {
	BLK = 11;
} else
if ( n >= 2355 && n < 2453 ) {
	BLK = 5;
} else
if ( n >= 2453 && n < 2560 ) {
	BLK = 12;
} else
if ( n >= 2560 && n < 2646 ) {
	BLK = 11;
} else
if ( n >= 2646 && n < 2688 ) {
	BLK = 13;
} else
if ( n >= 2688 && n < 2709 ) {
	BLK = 5;
} else
if ( n >= 2709 && n < 2816 ) {
	BLK = 12;
} else
if ( n >= 2816 && n < 2832 ) {
	BLK = 5;
} else
if ( n >= 2832 && n < 2880 ) {
	BLK = 6;
} else
if ( n >= 2880 && n < 2942 ) {
	BLK = 11;
} else
if ( n >= 2942 && n < 2965 ) {
	BLK = 5;
} else
if ( n >= 2965 && n < 3072 ) {
	BLK = 12;
} else
if ( n >= 3072 && n < 3175 ) {
	BLK = 5;
} else
if ( n >= 3175 && n < 3200 ) {
	BLK = 6;
} else
if ( n >= 3200 && n < 3232 ) {
	BLK = 11;
} else
if ( n >= 3232 && n < 3328 ) {
	BLK = 12;
} else
if ( n >= 3328 && n < 3400 ) {
	BLK = 5;
} else
if ( n >= 3400 && n < 3456 ) {
	BLK = 13;
} else
if ( n >= 3456 && n < 3475 ) {
	BLK = 5;
} else
if ( n >= 3475 && n < 3584 ) {
	BLK = 12;
} else
if ( n >= 3584 && n < 3609 ) {
	BLK = 11;
} else
if ( n >= 3609 && n < 3730 ) {
	BLK = 5;
} else
if ( n >= 3730 && n < 3840 ) {
	BLK = 12;
} else
if ( n >= 3840 && n < 3903 ) {
	BLK = 11;
} else
if ( n >= 3903 && n < 3985 ) {
	BLK = 5;
} else
if ( n >= 3985 && n < 4096 ) {
	BLK = 12;
} else
if ( n >= 4096 && n < 4160 ) {
	BLK = 6;
} else
if ( n >= 4160 && n < 4190 ) {
	BLK = 11;
} else
if ( n >= 4190 && n < 4224 ) {
	BLK = 13;
} else
if ( n >= 4224 && n < 4240 ) {
	BLK = 5;
} else
if ( n >= 4240 && n < 4352 ) {
	BLK = 12;
} else
if ( n >= 4352 && n < 4357 ) {
	BLK = 4;
} else
if ( n >= 4357 && n < 4480 ) {
	BLK = 6;
} else
if ( n >= 4480 && n < 4491 ) {
	BLK = 11;
} else
if ( n >= 4491 && n < 4494 ) {
	BLK = 5;
} else
if ( n >= 4494 && n < 4608 ) {
	BLK = 12;
} else
if ( n >= 4608 && n < 4623 ) {
	BLK = 4;
} else
if ( n >= 4623 && n < 4701 ) {
	BLK = 5;
} else
if ( n >= 4701 && n < 4800 ) {
	BLK = 6;
} else
if ( n >= 4800 && n < 4864 ) {
	BLK = 12;
} else
if ( n >= 4864 && n < 4882 ) {
	BLK = 4;
} else
if ( n >= 4882 && n < 4912 ) {
	BLK = 5;
} else
if ( n >= 4912 && n < 4992 ) {
	BLK = 13;
} else
if ( n >= 4992 && n < 5003 ) {
	BLK = 5;
} else
if ( n >= 5003 && n < 5120 ) {
	BLK = 12;
} else
if ( n >= 5120 && n < 5158 ) {
	BLK = 11;
} else
if ( n >= 5158 && n < 5258 ) {
	BLK = 5;
} else
if ( n >= 5258 && n < 5376 ) {
	BLK = 12;
} else
if ( n >= 5376 && n < 5440 ) {
	BLK = 6;
} else
if ( n >= 5440 && n < 5452 ) {
	BLK = 11;
} else
if ( n >= 5452 && n < 5512 ) {
	BLK = 5;
} else
if ( n >= 5512 && n < 5632 ) {
	BLK = 12;
} else
if ( n >= 5632 && n < 5760 ) {
	BLK = 6;
} else
if ( n >= 5760 && n < 5767 ) {
	BLK = 5;
} else
if ( n >= 5767 && n < 5888 ) {
	BLK = 12;
} else
if ( n >= 5888 && n < 5927 ) {
	BLK = 0;
} else
if ( n >= 5927 && n < 6080 ) {
	BLK = 6;
} else
if ( n >= 6080 && n < 6144 ) {
	BLK = 12;
} else
if ( n >= 6144 && n < 6251 ) {
	BLK = 0;
} else
if ( n >= 6251 && n < 6400 ) {
	BLK = 6;
} else
if ( n >= 6400 && n < 6493 ) {
	BLK = 0;
} else
if ( n >= 6493 && n < 6528 ) {
	BLK = 13;
} else
if ( n >= 6528 && n < 6538 ) {
	BLK = 0;
} else
if ( n >= 6538 && n < 6656 ) {
	BLK = 12;
} else
if ( n >= 6656 && n < 6720 ) {
	BLK = 6;
} else
if ( n >= 6720 && n < 6807 ) {
	BLK = 0;
} else
if ( n >= 6807 && n < 6912 ) {
	BLK = 12;
} else
if ( n >= 6912 && n < 7040 ) {
	BLK = 6;
} else
if ( n >= 7040 && n < 7076 ) {
	BLK = 0;
} else
if ( n >= 7076 && n < 7168 ) {
	BLK = 12;
} else
if ( n >= 7168 && n < 7219 ) {
	BLK = 0;
} else
if ( n >= 7219 && n < 7360 ) {
	BLK = 6;
} else
if ( n >= 7360 && n < 7424 ) {
	BLK = 12;
} else
if ( n >= 7424 && n < 7541 ) {
	BLK = 0;
} else
if ( n >= 7541 && n < 7680 ) {
	BLK = 6;
} else
if ( n >= 7680 && n < 7862 ) {
	BLK = 0;
} else
if ( n >= 7862 && n < 8000 ) {
	BLK = 6;
} else
if ( n >= 8000 && n < 8149 ) {
	BLK = 0;
} else
if ( n >= 8149 && n < 8192 ) {
	BLK = 12;
} else
if ( n >= 8192 && n < 8320 ) {
	BLK = 6;
} else
if ( n >= 8320 && n < 8507 ) {
	BLK = 0;
} else
if ( n >= 8507 && n < 8640 ) {
	BLK = 6;
} else
if ( n >= 8640 && n < 8829 ) {
	BLK = 0;
} else
if ( n >= 8829 && n < 8960 ) {
	BLK = 6;
} else
if ( n >= 8960 && n < 9152 ) {
	BLK = 0;
} else
if ( n >= 9152 && n < 9280 ) {
	BLK = 6;
} else
if ( n >= 9280 && n < 9474 ) {
	BLK = 0;
} else
if ( n >= 9474 && n < 9600 ) {
	BLK = 6;
} else
if ( n >= 9600 && n < 9795 ) {
	BLK = 0;
} else
if ( n >= 9795 && n < 9920 ) {
	BLK = 6;
} else
if ( n >= 9920 && n < 10118 ) {
	BLK = 0;
} else
if ( n >= 10118 && n < 10240 ) {
	BLK = 6;
} else
if ( n >= 10240 && n < 10439 ) {
	BLK = 0;
} else
if ( n >= 10439 && n < 10560 ) {
	BLK = 6;
} else
if ( n >= 10560 && n < 10760 ) {
	BLK = 0;
} else
if ( n >= 10760 && n < 10880 ) {
	BLK = 6;
} else
if ( n >= 10880 && n < 11084 ) {
	BLK = 0;
} else
if ( n >= 11084 && n < 11200 ) {
	BLK = 6;
} else
if ( n >= 11200 && n < 11405 ) {
	BLK = 0;
} else
if ( n >= 11405 && n < 11520 ) {
	BLK = 6;
} else
if ( n >= 11520 && n < 11726 ) {
	BLK = 0;
} else
if ( n >= 11726 && n < 11840 ) {
	BLK = 6;
} else
if ( n >= 11840 && n < 12049 ) {
	BLK = 0;
} else
if ( n >= 12049 && n < 12160 ) {
	BLK = 6;
} else
if ( n >= 12160 && n < 12370 ) {
	BLK = 0;
} else
if ( n >= 12370 && n < 12480 ) {
	BLK = 6;
} else
if ( n >= 12480 && n < 12691 ) {
	BLK = 0;
} else
if ( n >= 12691 && n < 12800 ) {
	BLK = 6;
} else
if ( n >= 12800 && n < 13014 ) {
	BLK = 0;
} else
if ( n >= 13014 && n < 13120 ) {
	BLK = 6;
} else
if ( n >= 13120 && n < 13335 ) {
	BLK = 0;
} else
if ( n >= 13335 && n < 13440 ) {
	BLK = 6;
} else
if ( n >= 13440 && n < 13656 ) {
	BLK = 0;
} else
if ( n >= 13656 && n < 13760 ) {
	BLK = 6;
} else
if ( n >= 13760 && n < 13979 ) {
	BLK = 0;
} else
if ( n >= 13979 && n < 14000 ) {
	BLK = 6;
} else
if ( n >= 14000 && n < 100000000 ) {
	BLK = 6;
}

#if 1
	int ii=BLK;
        #define SGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
                GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
                ( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		SGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		SGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		SGEMVT_KERNEL_ ( 320 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		SGEMVT_KERNEL_ ( 320 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		SGEMVT_KERNEL_ ( 384 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		SGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		SGEMVT_KERNEL_ ( 320 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		SGEMVT_KERNEL_ ( 256 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		SGEMVT_KERNEL_ ( 384 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		SGEMVT_KERNEL_ ( 128 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		SGEMVT_KERNEL_ ( 224 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		SGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		SGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		SGEMVT_KERNEL_ ( 384 , 1 , 8, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		SGEMVT_KERNEL_ ( 128 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		SGEMVT_KERNEL_ ( 64 , 2 , 8, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		SGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		SGEMVT_KERNEL_ ( 96 , 3 , 8, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		SGEMVT_KERNEL_ ( 96 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		SGEMVT_KERNEL_ ( 96 , 4 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

