#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
Thu Nov 27 10:53:56 JST 2014
Host on newton.aics27.riken.jp
Device is GeForce-GTX-TITAN-Black
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="newton.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-TITAN-Black";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(15)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_17	1
#define	KERNEL_4	1
#define	KERNEL_18	1
#define	KERNEL_7	1
#define	KERNEL_8	1
#define	KERNEL_9	1
#define	KERNEL_10	1
#define	KERNEL_11	1
#define	KERNEL_12	1
#define	KERNEL_0	1
#define	KERNEL_2	1
#define	KERNEL_3	1

if ( n >= 1 && n < 447 ) {
	BLK = 7;
} else
if ( n >= 447 && n < 780 ) {
	BLK = 3;
} else
if ( n >= 780 && n < 859 ) {
	BLK = 7;
} else
if ( n >= 859 && n < 1080 ) {
	BLK = 11;
} else
if ( n >= 1080 && n < 1554 ) {
	BLK = 3;
} else
if ( n >= 1554 && n < 1620 ) {
	BLK = 8;
} else
if ( n >= 1620 && n < 1920 ) {
	BLK = 17;
} else
if ( n >= 1920 && n < 2010 ) {
	BLK = 10;
} else
if ( n >= 2010 && n < 2067 ) {
	BLK = 4;
} else
if ( n >= 2067 && n < 2700 ) {
	BLK = 12;
} else
if ( n >= 2700 && n < 3715 ) {
	BLK = 18;
} else
if ( n >= 3715 && n < 3840 ) {
	BLK = 17;
} else
if ( n >= 3840 && n < 3885 ) {
	BLK = 0;
} else
if ( n >= 3885 && n < 4080 ) {
	BLK = 18;
} else
if ( n >= 4080 && n < 4188 ) {
	BLK = 0;
} else
if ( n >= 4188 && n < 4320 ) {
	BLK = 18;
} else
if ( n >= 4320 && n < 4481 ) {
	BLK = 0;
} else
if ( n >= 4481 && n < 4560 ) {
	BLK = 18;
} else
if ( n >= 4560 && n < 4585 ) {
	BLK = 0;
} else
if ( n >= 4585 && n < 7328 ) {
	BLK = 2;
} else
if ( n >= 7328 && n < 14000 ) {
	BLK = 9;
} else
if ( n >= 14000 && n < 100000000 ) {
	BLK = 9;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 288 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 352 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 352 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 32 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 288 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 64 , 4 , 4, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 64 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 384 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 32 , 4 , 3, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 96 , 2 , 6, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 32 , 3 , 5, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 96 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 96 , 2 , 1, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 352 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 288 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 32 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 224 , 1 , 2, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 384 , 1 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

